"Main interface for cloudfront service type defs"
from __future__ import annotations

from datetime import datetime
from typing import List
from mypy_boto3.type_defs import Literal, TypedDict


__all__ = (
    "ClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    "ClientCreateCloudFrontOriginAccessIdentityResponseTypeDef",
    "ClientCreateDistributionDistributionConfigAliasesTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientCreateDistributionDistributionConfigLoggingTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientCreateDistributionDistributionConfigOriginsTypeDef",
    "ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientCreateDistributionDistributionConfigRestrictionsTypeDef",
    "ClientCreateDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientCreateDistributionDistributionConfigTypeDef",
    "ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    "ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef",
    "ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientCreateDistributionResponseDistributionDistributionConfigTypeDef",
    "ClientCreateDistributionResponseDistributionTypeDef",
    "ClientCreateDistributionResponseTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef",
    "ClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef",
    "ClientCreateDistributionWithTagsResponseDistributionTypeDef",
    "ClientCreateDistributionWithTagsResponseTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef",
    "ClientCreateFieldLevelEncryptionConfigResponseTypeDef",
    "ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    "ClientCreateFieldLevelEncryptionProfileResponseTypeDef",
    "ClientCreateInvalidationInvalidationBatchPathsTypeDef",
    "ClientCreateInvalidationInvalidationBatchTypeDef",
    "ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef",
    "ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef",
    "ClientCreateInvalidationResponseInvalidationTypeDef",
    "ClientCreateInvalidationResponseTypeDef",
    "ClientCreatePublicKeyPublicKeyConfigTypeDef",
    "ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    "ClientCreatePublicKeyResponsePublicKeyTypeDef",
    "ClientCreatePublicKeyResponseTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    "ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef",
    "ClientCreateStreamingDistributionResponseTypeDef",
    "ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionStreamingDistributionConfigTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef",
    "ClientCreateStreamingDistributionWithTagsResponseTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef",
    "ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef",
    "ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientGetCloudFrontOriginAccessIdentityConfigResponseTypeDef",
    "ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    "ClientGetCloudFrontOriginAccessIdentityResponseTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef",
    "ClientGetDistributionConfigResponseDistributionConfigTypeDef",
    "ClientGetDistributionConfigResponseTypeDef",
    "ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    "ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef",
    "ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientGetDistributionResponseDistributionDistributionConfigTypeDef",
    "ClientGetDistributionResponseDistributionTypeDef",
    "ClientGetDistributionResponseTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef",
    "ClientGetFieldLevelEncryptionConfigResponseTypeDef",
    "ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionProfileConfigResponseTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    "ClientGetFieldLevelEncryptionProfileResponseTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    "ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef",
    "ClientGetFieldLevelEncryptionResponseTypeDef",
    "ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef",
    "ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef",
    "ClientGetInvalidationResponseInvalidationTypeDef",
    "ClientGetInvalidationResponseTypeDef",
    "ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef",
    "ClientGetPublicKeyConfigResponseTypeDef",
    "ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    "ClientGetPublicKeyResponsePublicKeyTypeDef",
    "ClientGetPublicKeyResponseTypeDef",
    "ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef",
    "ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef",
    "ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef",
    "ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef",
    "ClientGetStreamingDistributionConfigResponseTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    "ClientGetStreamingDistributionResponseStreamingDistributionTypeDef",
    "ClientGetStreamingDistributionResponseTypeDef",
    "ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef",
    "ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef",
    "ClientListCloudFrontOriginAccessIdentitiesResponseTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef",
    "ClientListDistributionsByWebAclIdResponseDistributionListTypeDef",
    "ClientListDistributionsByWebAclIdResponseTypeDef",
    "ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsAliasesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsOriginsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    "ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef",
    "ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef",
    "ClientListDistributionsResponseDistributionListItemsTypeDef",
    "ClientListDistributionsResponseDistributionListTypeDef",
    "ClientListDistributionsResponseTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef",
    "ClientListFieldLevelEncryptionConfigsResponseTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef",
    "ClientListFieldLevelEncryptionProfilesResponseTypeDef",
    "ClientListInvalidationsResponseInvalidationListItemsTypeDef",
    "ClientListInvalidationsResponseInvalidationListTypeDef",
    "ClientListInvalidationsResponseTypeDef",
    "ClientListPublicKeysResponsePublicKeyListItemsTypeDef",
    "ClientListPublicKeysResponsePublicKeyListTypeDef",
    "ClientListPublicKeysResponseTypeDef",
    "ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef",
    "ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef",
    "ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef",
    "ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef",
    "ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef",
    "ClientListStreamingDistributionsResponseTypeDef",
    "ClientListTagsForResourceResponseTagsItemsTypeDef",
    "ClientListTagsForResourceResponseTagsTypeDef",
    "ClientListTagsForResourceResponseTypeDef",
    "ClientTagResourceTagsItemsTypeDef",
    "ClientTagResourceTagsTypeDef",
    "ClientUntagResourceTagKeysTypeDef",
    "ClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    "ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    "ClientUpdateCloudFrontOriginAccessIdentityResponseTypeDef",
    "ClientUpdateDistributionDistributionConfigAliasesTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientUpdateDistributionDistributionConfigLoggingTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientUpdateDistributionDistributionConfigOriginsTypeDef",
    "ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientUpdateDistributionDistributionConfigRestrictionsTypeDef",
    "ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientUpdateDistributionDistributionConfigTypeDef",
    "ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef",
    "ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    "ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef",
    "ClientUpdateDistributionResponseDistributionTypeDef",
    "ClientUpdateDistributionResponseTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef",
    "ClientUpdateFieldLevelEncryptionConfigResponseTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    "ClientUpdateFieldLevelEncryptionProfileResponseTypeDef",
    "ClientUpdatePublicKeyPublicKeyConfigTypeDef",
    "ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    "ClientUpdatePublicKeyResponsePublicKeyTypeDef",
    "ClientUpdatePublicKeyResponseTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    "ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef",
    "ClientUpdateStreamingDistributionResponseTypeDef",
    "ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    "ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    "ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    "ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    "ClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef",
    "DistributionDeployedWaitWaiterConfigTypeDef",
    "InvalidationCompletedWaitWaiterConfigTypeDef",
    "ListCloudFrontOriginAccessIdentitiesPaginatePaginationConfigTypeDef",
    "ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef",
    "ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef",
    "ListCloudFrontOriginAccessIdentitiesPaginateResponseTypeDef",
    "ListDistributionsPaginatePaginationConfigTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef",
    "ListDistributionsPaginateResponseDistributionListItemsTypeDef",
    "ListDistributionsPaginateResponseDistributionListTypeDef",
    "ListDistributionsPaginateResponseTypeDef",
    "ListInvalidationsPaginatePaginationConfigTypeDef",
    "ListInvalidationsPaginateResponseInvalidationListItemsTypeDef",
    "ListInvalidationsPaginateResponseInvalidationListTypeDef",
    "ListInvalidationsPaginateResponseTypeDef",
    "ListStreamingDistributionsPaginatePaginationConfigTypeDef",
    "ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef",
    "ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef",
    "ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef",
    "ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef",
    "ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef",
    "ListStreamingDistributionsPaginateResponseTypeDef",
    "StreamingDistributionDeployedWaitWaiterConfigTypeDef",
)


_RequiredClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_RequiredClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_OptionalClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"Comment": str},
    total=False,
)


class ClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef(
    _RequiredClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
    _OptionalClientCreateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
):
    """
    The current configuration information for the identity.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``CloudFrontOriginAccessIdentityConfig`` object), a new origin access identity is created.
      If the ``CallerReference`` is a value already sent in a previous identity request, and the
      content of the ``CloudFrontOriginAccessIdentityConfig`` is identical to the original request
      (ignoring white space), the response includes the same information returned to the original
      request.
      If the ``CallerReference`` is a value you already sent in a previous request to create an
      identity, but the content of the ``CloudFrontOriginAccessIdentityConfig`` is different from
      the original request, CloudFront returns a ``CloudFrontOriginAccessIdentityAlreadyExists``
      error.
    """


_ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str, "Comment": str},
    total=False,
)


class ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef(
    _ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef
):
    pass


_ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef = TypedDict(
    "_ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    {
        "Id": str,
        "S3CanonicalUserId": str,
        "CloudFrontOriginAccessIdentityConfig": ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
    },
    total=False,
)


class ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef(
    _ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef
):
    """
    - **CloudFrontOriginAccessIdentity** *(dict) --*

      The origin access identity's information.
      - **Id** *(string) --*

        The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientCreateCloudFrontOriginAccessIdentityResponseTypeDef = TypedDict(
    "_ClientCreateCloudFrontOriginAccessIdentityResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentity": ClientCreateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateCloudFrontOriginAccessIdentityResponseTypeDef(
    _ClientCreateCloudFrontOriginAccessIdentityResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentity** *(dict) --*

        The origin access identity's information.
        - **Id** *(string) --*

          The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientCreateDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigAliasesTypeDef(
    _ClientCreateDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientCreateDistributionDistributionConfigCacheBehaviorsItemsTypeDef],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientCreateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateDistributionDistributionConfigLoggingTypeDef(
    _ClientCreateDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientCreateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientCreateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientCreateDistributionDistributionConfigOriginGroupsItemsTypeDef],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientCreateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientCreateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientCreateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigOriginsTypeDef",
    {"Quantity": int, "Items": List[ClientCreateDistributionDistributionConfigOriginsItemsTypeDef]},
    total=False,
)


class ClientCreateDistributionDistributionConfigOriginsTypeDef(
    _ClientCreateDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigRestrictionsTypeDef",
    {"GeoRestriction": ClientCreateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef},
    total=False,
)


class ClientCreateDistributionDistributionConfigRestrictionsTypeDef(
    _ClientCreateDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientCreateDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientCreateDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientCreateDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_RequiredClientCreateDistributionDistributionConfigTypeDef = TypedDict(
    "_RequiredClientCreateDistributionDistributionConfigTypeDef", {"CallerReference": str}
)
_OptionalClientCreateDistributionDistributionConfigTypeDef = TypedDict(
    "_OptionalClientCreateDistributionDistributionConfigTypeDef",
    {
        "Aliases": ClientCreateDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientCreateDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientCreateDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientCreateDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientCreateDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientCreateDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientCreateDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientCreateDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientCreateDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientCreateDistributionDistributionConfigTypeDef(
    _RequiredClientCreateDistributionDistributionConfigTypeDef,
    _OptionalClientCreateDistributionDistributionConfigTypeDef,
):
    """
    The distribution's configuration information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``DistributionConfig`` object), CloudFront creates a new distribution.
      If ``CallerReference`` is a value that you already sent in a previous request to create a
      distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef(
    _ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[ClientCreateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef(
    _ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef(
    _ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionDistributionConfigTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "Aliases": ClientCreateDistributionResponseDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientCreateDistributionResponseDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientCreateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientCreateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientCreateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientCreateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientCreateDistributionResponseDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientCreateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientCreateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionDistributionConfigTypeDef(
    _ClientCreateDistributionResponseDistributionDistributionConfigTypeDef
):
    pass


_ClientCreateDistributionResponseDistributionTypeDef = TypedDict(
    "_ClientCreateDistributionResponseDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "InProgressInvalidationBatches": int,
        "DomainName": str,
        "ActiveTrustedSigners": ClientCreateDistributionResponseDistributionActiveTrustedSignersTypeDef,
        "DistributionConfig": ClientCreateDistributionResponseDistributionDistributionConfigTypeDef,
        "AliasICPRecordals": List[
            ClientCreateDistributionResponseDistributionAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionResponseDistributionTypeDef(
    _ClientCreateDistributionResponseDistributionTypeDef
):
    """
    - **Distribution** *(dict) --*

      The distribution's information.
      - **Id** *(string) --*

        The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientCreateDistributionResponseTypeDef = TypedDict(
    "_ClientCreateDistributionResponseTypeDef",
    {
        "Distribution": ClientCreateDistributionResponseDistributionTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateDistributionResponseTypeDef(_ClientCreateDistributionResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Distribution** *(dict) --*

        The distribution's information.
        - **Id** *(string) --*

          The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef
):
    pass


_RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef = TypedDict(
    "_RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef = TypedDict(
    "_OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef",
    {
        "Aliases": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef(
    _RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef,
    _OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef,
):
    """
    - **DistributionConfig** *(dict) --***[REQUIRED]**

      A distribution configuration.
      - **CallerReference** *(string) --***[REQUIRED]**

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``DistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef",
    {"Items": List[ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsItemsTypeDef]},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef(
    _ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef
):
    pass


_RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef = TypedDict(
    "_RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef",
    {
        "DistributionConfig": ClientCreateDistributionWithTagsDistributionConfigWithTagsDistributionConfigTypeDef
    },
)
_OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef = TypedDict(
    "_OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef",
    {"Tags": ClientCreateDistributionWithTagsDistributionConfigWithTagsTagsTypeDef},
    total=False,
)


class ClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef(
    _RequiredClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef,
    _OptionalClientCreateDistributionWithTagsDistributionConfigWithTagsTypeDef,
):
    """
    The distribution's configuration information.
    - **DistributionConfig** *(dict) --***[REQUIRED]**

      A distribution configuration.
      - **CallerReference** *(string) --***[REQUIRED]**

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``DistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "Aliases": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef
):
    pass


_ClientCreateDistributionWithTagsResponseDistributionTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "InProgressInvalidationBatches": int,
        "DomainName": str,
        "ActiveTrustedSigners": ClientCreateDistributionWithTagsResponseDistributionActiveTrustedSignersTypeDef,
        "DistributionConfig": ClientCreateDistributionWithTagsResponseDistributionDistributionConfigTypeDef,
        "AliasICPRecordals": List[
            ClientCreateDistributionWithTagsResponseDistributionAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseDistributionTypeDef(
    _ClientCreateDistributionWithTagsResponseDistributionTypeDef
):
    """
    - **Distribution** *(dict) --*

      The distribution's information.
      - **Id** *(string) --*

        The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientCreateDistributionWithTagsResponseTypeDef = TypedDict(
    "_ClientCreateDistributionWithTagsResponseTypeDef",
    {
        "Distribution": ClientCreateDistributionWithTagsResponseDistributionTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateDistributionWithTagsResponseTypeDef(
    _ClientCreateDistributionWithTagsResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Distribution** *(dict) --*

        The distribution's information.
        - **Id** *(string) --*

          The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_RequiredClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_RequiredClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_OptionalClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    {
        "Comment": str,
        "QueryArgProfileConfig": ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef(
    _RequiredClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef,
    _OptionalClientCreateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef,
):
    """
    The request to create a new field-level encryption configuration.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique number that ensures the request can't be replayed.
    """


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "QueryArgProfileConfig": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionConfig": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef
):
    """
    - **FieldLevelEncryption** *(dict) --*

      Returned when you create a new field-level encryption configuration.
      - **Id** *(string) --*

        The configuration ID for a field-level encryption configuration which includes a set of
        profiles that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientCreateFieldLevelEncryptionConfigResponseTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionConfigResponseTypeDef",
    {
        "FieldLevelEncryption": ClientCreateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionConfigResponseTypeDef(
    _ClientCreateFieldLevelEncryptionConfigResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryption** *(dict) --*

        Returned when you create a new field-level encryption configuration.
        - **Id** *(string) --*

          The configuration ID for a field-level encryption configuration which includes a set of
          profiles that specify certain selected data fields to be encrypted by specific public
          keys.
    """


_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_RequiredClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_RequiredClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {"Name": str},
)
_OptionalClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_OptionalClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef(
    _RequiredClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
    _OptionalClientCreateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
):
    """
    The request to create a field-level encryption profile.
    - **Name** *(string) --***[REQUIRED]**

      Profile name for the field-level encryption profile.
    """


_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {
        "Name": str,
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef
):
    pass


_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionProfileConfig": ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef
):
    """
    - **FieldLevelEncryptionProfile** *(dict) --*

      Returned when you create a new field-level encryption profile.
      - **Id** *(string) --*

        The ID for a field-level encryption profile configuration which includes a set of profiles
        that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientCreateFieldLevelEncryptionProfileResponseTypeDef = TypedDict(
    "_ClientCreateFieldLevelEncryptionProfileResponseTypeDef",
    {
        "FieldLevelEncryptionProfile": ClientCreateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateFieldLevelEncryptionProfileResponseTypeDef(
    _ClientCreateFieldLevelEncryptionProfileResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionProfile** *(dict) --*

        Returned when you create a new field-level encryption profile.
        - **Id** *(string) --*

          The ID for a field-level encryption profile configuration which includes a set of profiles
          that specify certain selected data fields to be encrypted by specific public keys.
    """


_RequiredClientCreateInvalidationInvalidationBatchPathsTypeDef = TypedDict(
    "_RequiredClientCreateInvalidationInvalidationBatchPathsTypeDef", {"Quantity": int}
)
_OptionalClientCreateInvalidationInvalidationBatchPathsTypeDef = TypedDict(
    "_OptionalClientCreateInvalidationInvalidationBatchPathsTypeDef",
    {"Items": List[str]},
    total=False,
)


class ClientCreateInvalidationInvalidationBatchPathsTypeDef(
    _RequiredClientCreateInvalidationInvalidationBatchPathsTypeDef,
    _OptionalClientCreateInvalidationInvalidationBatchPathsTypeDef,
):
    """
    - **Paths** *(dict) --***[REQUIRED]**

      A complex type that contains information about the objects that you want to invalidate. For
      more information, see `Specifying the Objects to Invalidate
      <https://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/Invalidation.html#invalidation-specifying-objects>`__
      in the *Amazon CloudFront Developer Guide* .
      - **Quantity** *(integer) --***[REQUIRED]**

        The number of invalidation paths specified for the objects that you want to invalidate.
    """


_RequiredClientCreateInvalidationInvalidationBatchTypeDef = TypedDict(
    "_RequiredClientCreateInvalidationInvalidationBatchTypeDef",
    {"Paths": ClientCreateInvalidationInvalidationBatchPathsTypeDef},
)
_OptionalClientCreateInvalidationInvalidationBatchTypeDef = TypedDict(
    "_OptionalClientCreateInvalidationInvalidationBatchTypeDef",
    {"CallerReference": str},
    total=False,
)


class ClientCreateInvalidationInvalidationBatchTypeDef(
    _RequiredClientCreateInvalidationInvalidationBatchTypeDef,
    _OptionalClientCreateInvalidationInvalidationBatchTypeDef,
):
    """
    The batch information for the invalidation.
    - **Paths** *(dict) --***[REQUIRED]**

      A complex type that contains information about the objects that you want to invalidate. For
      more information, see `Specifying the Objects to Invalidate
      <https://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/Invalidation.html#invalidation-specifying-objects>`__
      in the *Amazon CloudFront Developer Guide* .
      - **Quantity** *(integer) --***[REQUIRED]**

        The number of invalidation paths specified for the objects that you want to invalidate.
    """


_ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef = TypedDict(
    "_ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef(
    _ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef
):
    pass


_ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef = TypedDict(
    "_ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef",
    {
        "Paths": ClientCreateInvalidationResponseInvalidationInvalidationBatchPathsTypeDef,
        "CallerReference": str,
    },
    total=False,
)


class ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef(
    _ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef
):
    pass


_ClientCreateInvalidationResponseInvalidationTypeDef = TypedDict(
    "_ClientCreateInvalidationResponseInvalidationTypeDef",
    {
        "Id": str,
        "Status": str,
        "CreateTime": datetime,
        "InvalidationBatch": ClientCreateInvalidationResponseInvalidationInvalidationBatchTypeDef,
    },
    total=False,
)


class ClientCreateInvalidationResponseInvalidationTypeDef(
    _ClientCreateInvalidationResponseInvalidationTypeDef
):
    pass


_ClientCreateInvalidationResponseTypeDef = TypedDict(
    "_ClientCreateInvalidationResponseTypeDef",
    {"Location": str, "Invalidation": ClientCreateInvalidationResponseInvalidationTypeDef},
    total=False,
)


class ClientCreateInvalidationResponseTypeDef(_ClientCreateInvalidationResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Location** *(string) --*

        The fully qualified URI of the distribution and invalidation batch request, including the
        ``Invalidation ID`` .
    """


_RequiredClientCreatePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_RequiredClientCreatePublicKeyPublicKeyConfigTypeDef", {"CallerReference": str}
)
_OptionalClientCreatePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_OptionalClientCreatePublicKeyPublicKeyConfigTypeDef",
    {"Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientCreatePublicKeyPublicKeyConfigTypeDef(
    _RequiredClientCreatePublicKeyPublicKeyConfigTypeDef,
    _OptionalClientCreatePublicKeyPublicKeyConfigTypeDef,
):
    """
    The request to add a public key to CloudFront.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique number that ensures that the request can't be replayed.
    """


_ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    {"CallerReference": str, "Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef(
    _ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef
):
    pass


_ClientCreatePublicKeyResponsePublicKeyTypeDef = TypedDict(
    "_ClientCreatePublicKeyResponsePublicKeyTypeDef",
    {
        "Id": str,
        "CreatedTime": datetime,
        "PublicKeyConfig": ClientCreatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef,
    },
    total=False,
)


class ClientCreatePublicKeyResponsePublicKeyTypeDef(_ClientCreatePublicKeyResponsePublicKeyTypeDef):
    """
    - **PublicKey** *(dict) --*

      Returned when you add a public key.
      - **Id** *(string) --*

        A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientCreatePublicKeyResponseTypeDef = TypedDict(
    "_ClientCreatePublicKeyResponseTypeDef",
    {"PublicKey": ClientCreatePublicKeyResponsePublicKeyTypeDef, "Location": str, "ETag": str},
    total=False,
)


class ClientCreatePublicKeyResponseTypeDef(_ClientCreatePublicKeyResponseTypeDef):
    """
    - *(dict) --*

      - **PublicKey** *(dict) --*

        Returned when you add a public key.
        - **Id** *(string) --*

          A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[
            ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "S3Origin": ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef
):
    pass


_ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "ActiveTrustedSigners": ClientCreateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef,
        "StreamingDistributionConfig": ClientCreateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef,
    },
    total=False,
)


class ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef(
    _ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef
):
    """
    - **StreamingDistribution** *(dict) --*

      The streaming distribution's information.
      - **Id** *(string) --*

        The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientCreateStreamingDistributionResponseTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionResponseTypeDef",
    {
        "StreamingDistribution": ClientCreateStreamingDistributionResponseStreamingDistributionTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateStreamingDistributionResponseTypeDef(
    _ClientCreateStreamingDistributionResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistribution** *(dict) --*

        The streaming distribution's information.
        - **Id** *(string) --*

          The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_RequiredClientCreateStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_RequiredClientCreateStreamingDistributionStreamingDistributionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientCreateStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_OptionalClientCreateStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "S3Origin": ClientCreateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientCreateStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientCreateStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientCreateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientCreateStreamingDistributionStreamingDistributionConfigTypeDef(
    _RequiredClientCreateStreamingDistributionStreamingDistributionConfigTypeDef,
    _OptionalClientCreateStreamingDistributionStreamingDistributionConfigTypeDef,
):
    """
    The streaming distribution's configuration information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
      If ``CallerReference`` is a value that you already sent in a previous request to create a
      distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[
            ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
        ],
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "S3Origin": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "ActiveTrustedSigners": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionActiveTrustedSignersTypeDef,
        "StreamingDistributionConfig": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionStreamingDistributionConfigTypeDef,
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef
):
    """
    - **StreamingDistribution** *(dict) --*

      The streaming distribution's information.
      - **Id** *(string) --*

        The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientCreateStreamingDistributionWithTagsResponseTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsResponseTypeDef",
    {
        "StreamingDistribution": ClientCreateStreamingDistributionWithTagsResponseStreamingDistributionTypeDef,
        "Location": str,
        "ETag": str,
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsResponseTypeDef(
    _ClientCreateStreamingDistributionWithTagsResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistribution** *(dict) --*

        The streaming distribution's information.
        - **Id** *(string) --*

          The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef = TypedDict(
    "_RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef = TypedDict(
    "_OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef",
    {
        "S3Origin": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef(
    _RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef,
    _OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef,
):
    """
    - **StreamingDistributionConfig** *(dict) --***[REQUIRED]**

      A streaming distribution Configuration.
      - **CallerReference** *(string) --***[REQUIRED]**

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef
):
    pass


_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef = TypedDict(
    "_ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef",
    {
        "Items": List[
            ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsItemsTypeDef
        ]
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef(
    _ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef
):
    pass


_RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef = TypedDict(
    "_RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef",
    {
        "StreamingDistributionConfig": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsStreamingDistributionConfigTypeDef
    },
)
_OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef = TypedDict(
    "_OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef",
    {
        "Tags": ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTagsTypeDef
    },
    total=False,
)


class ClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef(
    _RequiredClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef,
    _OptionalClientCreateStreamingDistributionWithTagsStreamingDistributionConfigWithTagsTypeDef,
):
    """
    The streaming distribution's configuration information.
    - **StreamingDistributionConfig** *(dict) --***[REQUIRED]**

      A streaming distribution Configuration.
      - **CallerReference** *(string) --***[REQUIRED]**

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str, "Comment": str},
    total=False,
)


class ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef(
    _ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef
):
    """
    - **CloudFrontOriginAccessIdentityConfig** *(dict) --*

      The origin access identity's configuration information.
      - **CallerReference** *(string) --*

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``CloudFrontOriginAccessIdentityConfig`` object), a new origin access identity is created.
        If the ``CallerReference`` is a value already sent in a previous identity request, and the
        content of the ``CloudFrontOriginAccessIdentityConfig`` is identical to the original request
        (ignoring white space), the response includes the same information returned to the original
        request.
        If the ``CallerReference`` is a value you already sent in a previous request to create an
        identity, but the content of the ``CloudFrontOriginAccessIdentityConfig`` is different from
        the original request, CloudFront returns a ``CloudFrontOriginAccessIdentityAlreadyExists``
        error.
    """


_ClientGetCloudFrontOriginAccessIdentityConfigResponseTypeDef = TypedDict(
    "_ClientGetCloudFrontOriginAccessIdentityConfigResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentityConfig": ClientGetCloudFrontOriginAccessIdentityConfigResponseCloudFrontOriginAccessIdentityConfigTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetCloudFrontOriginAccessIdentityConfigResponseTypeDef(
    _ClientGetCloudFrontOriginAccessIdentityConfigResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentityConfig** *(dict) --*

        The origin access identity's configuration information.
        - **CallerReference** *(string) --*

          A unique value (for example, a date-time stamp) that ensures that the request can't be
          replayed.
          If the value of ``CallerReference`` is new (regardless of the content of the
          ``CloudFrontOriginAccessIdentityConfig`` object), a new origin access identity is created.
          If the ``CallerReference`` is a value already sent in a previous identity request, and the
          content of the ``CloudFrontOriginAccessIdentityConfig`` is identical to the original
          request (ignoring white space), the response includes the same information returned to the
          original request.
          If the ``CallerReference`` is a value you already sent in a previous request to create an
          identity, but the content of the ``CloudFrontOriginAccessIdentityConfig`` is different
          from the original request, CloudFront returns a
          ``CloudFrontOriginAccessIdentityAlreadyExists`` error.
    """


_ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str, "Comment": str},
    total=False,
)


class ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef(
    _ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef
):
    pass


_ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef = TypedDict(
    "_ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    {
        "Id": str,
        "S3CanonicalUserId": str,
        "CloudFrontOriginAccessIdentityConfig": ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
    },
    total=False,
)


class ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef(
    _ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef
):
    """
    - **CloudFrontOriginAccessIdentity** *(dict) --*

      The origin access identity's information.
      - **Id** *(string) --*

        The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientGetCloudFrontOriginAccessIdentityResponseTypeDef = TypedDict(
    "_ClientGetCloudFrontOriginAccessIdentityResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentity": ClientGetCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetCloudFrontOriginAccessIdentityResponseTypeDef(
    _ClientGetCloudFrontOriginAccessIdentityResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentity** *(dict) --*

        The origin access identity's information.
        - **Id** *(string) --*

          The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientGetDistributionConfigResponseDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientGetDistributionConfigResponseDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientGetDistributionConfigResponseDistributionConfigOriginsItemsTypeDef],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientGetDistributionConfigResponseDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef
):
    pass


_ClientGetDistributionConfigResponseDistributionConfigTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "Aliases": ClientGetDistributionConfigResponseDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientGetDistributionConfigResponseDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientGetDistributionConfigResponseDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientGetDistributionConfigResponseDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientGetDistributionConfigResponseDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientGetDistributionConfigResponseDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientGetDistributionConfigResponseDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientGetDistributionConfigResponseDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientGetDistributionConfigResponseDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientGetDistributionConfigResponseDistributionConfigTypeDef(
    _ClientGetDistributionConfigResponseDistributionConfigTypeDef
):
    """
    - **DistributionConfig** *(dict) --*

      The distribution's configuration information.
      - **CallerReference** *(string) --*

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``DistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientGetDistributionConfigResponseTypeDef = TypedDict(
    "_ClientGetDistributionConfigResponseTypeDef",
    {
        "DistributionConfig": ClientGetDistributionConfigResponseDistributionConfigTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetDistributionConfigResponseTypeDef(_ClientGetDistributionConfigResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **DistributionConfig** *(dict) --*

        The distribution's configuration information.
        - **CallerReference** *(string) --*

          A unique value (for example, a date-time stamp) that ensures that the request can't be
          replayed.
          If the value of ``CallerReference`` is new (regardless of the content of the
          ``DistributionConfig`` object), CloudFront creates a new distribution.
          If ``CallerReference`` is a value that you already sent in a previous request to create a
          distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientGetDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef(
    _ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[ClientGetDistributionResponseDistributionActiveTrustedSignersItemsTypeDef],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef(
    _ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef(
    _ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientGetDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_ClientGetDistributionResponseDistributionDistributionConfigTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "Aliases": ClientGetDistributionResponseDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientGetDistributionResponseDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientGetDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientGetDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientGetDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientGetDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientGetDistributionResponseDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientGetDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientGetDistributionResponseDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientGetDistributionResponseDistributionDistributionConfigTypeDef(
    _ClientGetDistributionResponseDistributionDistributionConfigTypeDef
):
    pass


_ClientGetDistributionResponseDistributionTypeDef = TypedDict(
    "_ClientGetDistributionResponseDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "InProgressInvalidationBatches": int,
        "DomainName": str,
        "ActiveTrustedSigners": ClientGetDistributionResponseDistributionActiveTrustedSignersTypeDef,
        "DistributionConfig": ClientGetDistributionResponseDistributionDistributionConfigTypeDef,
        "AliasICPRecordals": List[
            ClientGetDistributionResponseDistributionAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientGetDistributionResponseDistributionTypeDef(
    _ClientGetDistributionResponseDistributionTypeDef
):
    """
    - **Distribution** *(dict) --*

      The distribution's information.
      - **Id** *(string) --*

        The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientGetDistributionResponseTypeDef = TypedDict(
    "_ClientGetDistributionResponseTypeDef",
    {"Distribution": ClientGetDistributionResponseDistributionTypeDef, "ETag": str},
    total=False,
)


class ClientGetDistributionResponseTypeDef(_ClientGetDistributionResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Distribution** *(dict) --*

        The distribution's information.
        - **Id** *(string) --*

          The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "QueryArgProfileConfig": ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef
):
    """
    - **FieldLevelEncryptionConfig** *(dict) --*

      Return the field-level encryption configuration information.
      - **CallerReference** *(string) --*

        A unique number that ensures the request can't be replayed.
    """


_ClientGetFieldLevelEncryptionConfigResponseTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionConfigResponseTypeDef",
    {
        "FieldLevelEncryptionConfig": ClientGetFieldLevelEncryptionConfigResponseFieldLevelEncryptionConfigTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionConfigResponseTypeDef(
    _ClientGetFieldLevelEncryptionConfigResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionConfig** *(dict) --*

        Return the field-level encryption configuration information.
        - **CallerReference** *(string) --*

          A unique number that ensures the request can't be replayed.
    """


_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef",
    {
        "Name": str,
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef
):
    """
    - **FieldLevelEncryptionProfileConfig** *(dict) --*

      Return the field-level encryption profile configuration information.
      - **Name** *(string) --*

        Profile name for the field-level encryption profile.
    """


_ClientGetFieldLevelEncryptionProfileConfigResponseTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileConfigResponseTypeDef",
    {
        "FieldLevelEncryptionProfileConfig": ClientGetFieldLevelEncryptionProfileConfigResponseFieldLevelEncryptionProfileConfigTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileConfigResponseTypeDef(
    _ClientGetFieldLevelEncryptionProfileConfigResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionProfileConfig** *(dict) --*

        Return the field-level encryption profile configuration information.
        - **Name** *(string) --*

          Profile name for the field-level encryption profile.
    """


_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {
        "Name": str,
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionProfileConfig": ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef
):
    """
    - **FieldLevelEncryptionProfile** *(dict) --*

      Return the field-level encryption profile information.
      - **Id** *(string) --*

        The ID for a field-level encryption profile configuration which includes a set of profiles
        that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientGetFieldLevelEncryptionProfileResponseTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionProfileResponseTypeDef",
    {
        "FieldLevelEncryptionProfile": ClientGetFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionProfileResponseTypeDef(
    _ClientGetFieldLevelEncryptionProfileResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionProfile** *(dict) --*

        Return the field-level encryption profile information.
        - **Id** *(string) --*

          The ID for a field-level encryption profile configuration which includes a set of profiles
          that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "QueryArgProfileConfig": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef
):
    pass


_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionConfig": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef(
    _ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef
):
    """
    - **FieldLevelEncryption** *(dict) --*

      Return the field-level encryption configuration information.
      - **Id** *(string) --*

        The configuration ID for a field-level encryption configuration which includes a set of
        profiles that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientGetFieldLevelEncryptionResponseTypeDef = TypedDict(
    "_ClientGetFieldLevelEncryptionResponseTypeDef",
    {
        "FieldLevelEncryption": ClientGetFieldLevelEncryptionResponseFieldLevelEncryptionTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetFieldLevelEncryptionResponseTypeDef(_ClientGetFieldLevelEncryptionResponseTypeDef):
    """
    - *(dict) --*

      - **FieldLevelEncryption** *(dict) --*

        Return the field-level encryption configuration information.
        - **Id** *(string) --*

          The configuration ID for a field-level encryption configuration which includes a set of
          profiles that specify certain selected data fields to be encrypted by specific public
          keys.
    """


_ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef = TypedDict(
    "_ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef(
    _ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef
):
    pass


_ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef = TypedDict(
    "_ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef",
    {
        "Paths": ClientGetInvalidationResponseInvalidationInvalidationBatchPathsTypeDef,
        "CallerReference": str,
    },
    total=False,
)


class ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef(
    _ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef
):
    pass


_ClientGetInvalidationResponseInvalidationTypeDef = TypedDict(
    "_ClientGetInvalidationResponseInvalidationTypeDef",
    {
        "Id": str,
        "Status": str,
        "CreateTime": datetime,
        "InvalidationBatch": ClientGetInvalidationResponseInvalidationInvalidationBatchTypeDef,
    },
    total=False,
)


class ClientGetInvalidationResponseInvalidationTypeDef(
    _ClientGetInvalidationResponseInvalidationTypeDef
):
    """
    - **Invalidation** *(dict) --*

      The invalidation's information. For more information, see `Invalidation Complex Type
      <https://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/InvalidationDatatype.html>`__
      .
      - **Id** *(string) --*

        The identifier for the invalidation request. For example: ``IDFDVBD632BHDS5`` .
    """


_ClientGetInvalidationResponseTypeDef = TypedDict(
    "_ClientGetInvalidationResponseTypeDef",
    {"Invalidation": ClientGetInvalidationResponseInvalidationTypeDef},
    total=False,
)


class ClientGetInvalidationResponseTypeDef(_ClientGetInvalidationResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Invalidation** *(dict) --*

        The invalidation's information. For more information, see `Invalidation Complex Type
        <https://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/InvalidationDatatype.html>`__
        .
        - **Id** *(string) --*

          The identifier for the invalidation request. For example: ``IDFDVBD632BHDS5`` .
    """


_ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef = TypedDict(
    "_ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef",
    {"CallerReference": str, "Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef(
    _ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef
):
    """
    - **PublicKeyConfig** *(dict) --*

      Return the result for the public key configuration.
      - **CallerReference** *(string) --*

        A unique number that ensures that the request can't be replayed.
    """


_ClientGetPublicKeyConfigResponseTypeDef = TypedDict(
    "_ClientGetPublicKeyConfigResponseTypeDef",
    {"PublicKeyConfig": ClientGetPublicKeyConfigResponsePublicKeyConfigTypeDef, "ETag": str},
    total=False,
)


class ClientGetPublicKeyConfigResponseTypeDef(_ClientGetPublicKeyConfigResponseTypeDef):
    """
    - *(dict) --*

      - **PublicKeyConfig** *(dict) --*

        Return the result for the public key configuration.
        - **CallerReference** *(string) --*

          A unique number that ensures that the request can't be replayed.
    """


_ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    {"CallerReference": str, "Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef(
    _ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef
):
    pass


_ClientGetPublicKeyResponsePublicKeyTypeDef = TypedDict(
    "_ClientGetPublicKeyResponsePublicKeyTypeDef",
    {
        "Id": str,
        "CreatedTime": datetime,
        "PublicKeyConfig": ClientGetPublicKeyResponsePublicKeyPublicKeyConfigTypeDef,
    },
    total=False,
)


class ClientGetPublicKeyResponsePublicKeyTypeDef(_ClientGetPublicKeyResponsePublicKeyTypeDef):
    """
    - **PublicKey** *(dict) --*

      Return the public key.
      - **Id** *(string) --*

        A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientGetPublicKeyResponseTypeDef = TypedDict(
    "_ClientGetPublicKeyResponseTypeDef",
    {"PublicKey": ClientGetPublicKeyResponsePublicKeyTypeDef, "ETag": str},
    total=False,
)


class ClientGetPublicKeyResponseTypeDef(_ClientGetPublicKeyResponseTypeDef):
    """
    - *(dict) --*

      - **PublicKey** *(dict) --*

        Return the public key.
        - **Id** *(string) --*

          A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef(
    _ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef(
    _ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef(
    _ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "S3Origin": ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef(
    _ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef
):
    """
    - **StreamingDistributionConfig** *(dict) --*

      The streaming distribution's configuration information.
      - **CallerReference** *(string) --*

        A unique value (for example, a date-time stamp) that ensures that the request can't be
        replayed.
        If the value of ``CallerReference`` is new (regardless of the content of the
        ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
        If ``CallerReference`` is a value that you already sent in a previous request to create a
        distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientGetStreamingDistributionConfigResponseTypeDef = TypedDict(
    "_ClientGetStreamingDistributionConfigResponseTypeDef",
    {
        "StreamingDistributionConfig": ClientGetStreamingDistributionConfigResponseStreamingDistributionConfigTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetStreamingDistributionConfigResponseTypeDef(
    _ClientGetStreamingDistributionConfigResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistributionConfig** *(dict) --*

        The streaming distribution's configuration information.
        - **CallerReference** *(string) --*

          A unique value (for example, a date-time stamp) that ensures that the request can't be
          replayed.
          If the value of ``CallerReference`` is new (regardless of the content of the
          ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
          If ``CallerReference`` is a value that you already sent in a previous request to create a
          distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[
            ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
        ],
    },
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "S3Origin": ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef
):
    pass


_ClientGetStreamingDistributionResponseStreamingDistributionTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseStreamingDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "ActiveTrustedSigners": ClientGetStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef,
        "StreamingDistributionConfig": ClientGetStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef,
    },
    total=False,
)


class ClientGetStreamingDistributionResponseStreamingDistributionTypeDef(
    _ClientGetStreamingDistributionResponseStreamingDistributionTypeDef
):
    """
    - **StreamingDistribution** *(dict) --*

      The streaming distribution's information.
      - **Id** *(string) --*

        The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientGetStreamingDistributionResponseTypeDef = TypedDict(
    "_ClientGetStreamingDistributionResponseTypeDef",
    {
        "StreamingDistribution": ClientGetStreamingDistributionResponseStreamingDistributionTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientGetStreamingDistributionResponseTypeDef(_ClientGetStreamingDistributionResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistribution** *(dict) --*

        The streaming distribution's information.
        - **Id** *(string) --*

          The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef = TypedDict(
    "_ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef",
    {"Id": str, "S3CanonicalUserId": str, "Comment": str},
    total=False,
)


class ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef(
    _ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef
):
    pass


_ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef = TypedDict(
    "_ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[
            ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListItemsTypeDef
        ],
    },
    total=False,
)


class ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef(
    _ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef
):
    """
    - **CloudFrontOriginAccessIdentityList** *(dict) --*

      The ``CloudFrontOriginAccessIdentityList`` type.
      - **Marker** *(string) --*

        Use this when paginating results to indicate where to begin in your list of origin access
        identities. The results include identities in the list that occur after the marker. To get
        the next page of results, set the ``Marker`` to the value of the ``NextMarker`` from the
        current page's response (which is also the ID of the last identity on that page).
    """


_ClientListCloudFrontOriginAccessIdentitiesResponseTypeDef = TypedDict(
    "_ClientListCloudFrontOriginAccessIdentitiesResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentityList": ClientListCloudFrontOriginAccessIdentitiesResponseCloudFrontOriginAccessIdentityListTypeDef
    },
    total=False,
)


class ClientListCloudFrontOriginAccessIdentitiesResponseTypeDef(
    _ClientListCloudFrontOriginAccessIdentitiesResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentityList** *(dict) --*

        The ``CloudFrontOriginAccessIdentityList`` type.
        - **Marker** *(string) --*

          Use this when paginating results to indicate where to begin in your list of origin access
          identities. The results include identities in the list that occur after the marker. To get
          the next page of results, set the ``Marker`` to the value of the ``NextMarker`` from the
          current page's response (which is also the ID of the last identity on that page).
    """


_ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef",
    {
        "GeoRestriction": ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "Aliases": ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasesTypeDef,
        "Origins": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginsTypeDef,
        "OriginGroups": ClientListDistributionsByWebAclIdResponseDistributionListItemsOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientListDistributionsByWebAclIdResponseDistributionListItemsDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientListDistributionsByWebAclIdResponseDistributionListItemsCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientListDistributionsByWebAclIdResponseDistributionListItemsCustomErrorResponsesTypeDef,
        "Comment": str,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientListDistributionsByWebAclIdResponseDistributionListItemsViewerCertificateTypeDef,
        "Restrictions": ClientListDistributionsByWebAclIdResponseDistributionListItemsRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
        "AliasICPRecordals": List[
            ClientListDistributionsByWebAclIdResponseDistributionListItemsAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef
):
    pass


_ClientListDistributionsByWebAclIdResponseDistributionListTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseDistributionListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[ClientListDistributionsByWebAclIdResponseDistributionListItemsTypeDef],
    },
    total=False,
)


class ClientListDistributionsByWebAclIdResponseDistributionListTypeDef(
    _ClientListDistributionsByWebAclIdResponseDistributionListTypeDef
):
    """
    - **DistributionList** *(dict) --*

      The ``DistributionList`` type.
      - **Marker** *(string) --*

        The value you provided for the ``Marker`` request parameter.
    """


_ClientListDistributionsByWebAclIdResponseTypeDef = TypedDict(
    "_ClientListDistributionsByWebAclIdResponseTypeDef",
    {"DistributionList": ClientListDistributionsByWebAclIdResponseDistributionListTypeDef},
    total=False,
)


class ClientListDistributionsByWebAclIdResponseTypeDef(
    _ClientListDistributionsByWebAclIdResponseTypeDef
):
    """
    - *(dict) --*

      The response to a request to list the distributions that are associated with a specified AWS
      WAF web ACL.
      - **DistributionList** *(dict) --*

        The ``DistributionList`` type.
        - **Marker** *(string) --*

          The value you provided for the ``Marker`` request parameter.
    """


_ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsAliasesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsAliasesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsAliasesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef(
    _ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientListDistributionsResponseDistributionListItemsOriginGroupsItemsTypeDef],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientListDistributionsResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientListDistributionsResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsOriginsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientListDistributionsResponseDistributionListItemsOriginsItemsTypeDef],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsOriginsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsOriginsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef(
    _ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef",
    {
        "GeoRestriction": ClientListDistributionsResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef(
    _ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListItemsTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListItemsTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "Aliases": ClientListDistributionsResponseDistributionListItemsAliasesTypeDef,
        "Origins": ClientListDistributionsResponseDistributionListItemsOriginsTypeDef,
        "OriginGroups": ClientListDistributionsResponseDistributionListItemsOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientListDistributionsResponseDistributionListItemsDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientListDistributionsResponseDistributionListItemsCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientListDistributionsResponseDistributionListItemsCustomErrorResponsesTypeDef,
        "Comment": str,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientListDistributionsResponseDistributionListItemsViewerCertificateTypeDef,
        "Restrictions": ClientListDistributionsResponseDistributionListItemsRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
        "AliasICPRecordals": List[
            ClientListDistributionsResponseDistributionListItemsAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListItemsTypeDef(
    _ClientListDistributionsResponseDistributionListItemsTypeDef
):
    pass


_ClientListDistributionsResponseDistributionListTypeDef = TypedDict(
    "_ClientListDistributionsResponseDistributionListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[ClientListDistributionsResponseDistributionListItemsTypeDef],
    },
    total=False,
)


class ClientListDistributionsResponseDistributionListTypeDef(
    _ClientListDistributionsResponseDistributionListTypeDef
):
    """
    - **DistributionList** *(dict) --*

      The ``DistributionList`` type.
      - **Marker** *(string) --*

        The value you provided for the ``Marker`` request parameter.
    """


_ClientListDistributionsResponseTypeDef = TypedDict(
    "_ClientListDistributionsResponseTypeDef",
    {"DistributionList": ClientListDistributionsResponseDistributionListTypeDef},
    total=False,
)


class ClientListDistributionsResponseTypeDef(_ClientListDistributionsResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **DistributionList** *(dict) --*

        The ``DistributionList`` type.
        - **Marker** *(string) --*

          The value you provided for the ``Marker`` request parameter.
    """


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "Comment": str,
        "QueryArgProfileConfig": ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef
):
    pass


_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef",
    {
        "NextMarker": str,
        "MaxItems": int,
        "Quantity": int,
        "Items": List[
            ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListItemsTypeDef
        ],
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef
):
    """
    - **FieldLevelEncryptionList** *(dict) --*

      Returns a list of all field-level encryption configurations that have been created in
      CloudFront for this account.
      - **NextMarker** *(string) --*

        If there are more elements to be listed, this element is present and contains the value that
        you can use for the ``Marker`` request parameter to continue listing your configurations
        where you left off.
    """


_ClientListFieldLevelEncryptionConfigsResponseTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionConfigsResponseTypeDef",
    {
        "FieldLevelEncryptionList": ClientListFieldLevelEncryptionConfigsResponseFieldLevelEncryptionListTypeDef
    },
    total=False,
)


class ClientListFieldLevelEncryptionConfigsResponseTypeDef(
    _ClientListFieldLevelEncryptionConfigsResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionList** *(dict) --*

        Returns a list of all field-level encryption configurations that have been created in
        CloudFront for this account.
        - **NextMarker** *(string) --*

          If there are more elements to be listed, this element is present and contains the value
          that you can use for the ``Marker`` request parameter to continue listing your
          configurations where you left off.
    """


_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef
):
    pass


_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef
):
    pass


_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "Name": str,
        "EncryptionEntities": ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsEncryptionEntitiesTypeDef,
        "Comment": str,
    },
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef
):
    pass


_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef",
    {
        "NextMarker": str,
        "MaxItems": int,
        "Quantity": int,
        "Items": List[
            ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListItemsTypeDef
        ],
    },
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef
):
    """
    - **FieldLevelEncryptionProfileList** *(dict) --*

      Returns a list of the field-level encryption profiles that have been created in CloudFront for
      this account.
      - **NextMarker** *(string) --*

        If there are more elements to be listed, this element is present and contains the value that
        you can use for the ``Marker`` request parameter to continue listing your profiles where you
        left off.
    """


_ClientListFieldLevelEncryptionProfilesResponseTypeDef = TypedDict(
    "_ClientListFieldLevelEncryptionProfilesResponseTypeDef",
    {
        "FieldLevelEncryptionProfileList": ClientListFieldLevelEncryptionProfilesResponseFieldLevelEncryptionProfileListTypeDef
    },
    total=False,
)


class ClientListFieldLevelEncryptionProfilesResponseTypeDef(
    _ClientListFieldLevelEncryptionProfilesResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionProfileList** *(dict) --*

        Returns a list of the field-level encryption profiles that have been created in CloudFront
        for this account.
        - **NextMarker** *(string) --*

          If there are more elements to be listed, this element is present and contains the value
          that you can use for the ``Marker`` request parameter to continue listing your profiles
          where you left off.
    """


_ClientListInvalidationsResponseInvalidationListItemsTypeDef = TypedDict(
    "_ClientListInvalidationsResponseInvalidationListItemsTypeDef",
    {"Id": str, "CreateTime": datetime, "Status": str},
    total=False,
)


class ClientListInvalidationsResponseInvalidationListItemsTypeDef(
    _ClientListInvalidationsResponseInvalidationListItemsTypeDef
):
    pass


_ClientListInvalidationsResponseInvalidationListTypeDef = TypedDict(
    "_ClientListInvalidationsResponseInvalidationListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[ClientListInvalidationsResponseInvalidationListItemsTypeDef],
    },
    total=False,
)


class ClientListInvalidationsResponseInvalidationListTypeDef(
    _ClientListInvalidationsResponseInvalidationListTypeDef
):
    """
    - **InvalidationList** *(dict) --*

      Information about invalidation batches.
      - **Marker** *(string) --*

        The value that you provided for the ``Marker`` request parameter.
    """


_ClientListInvalidationsResponseTypeDef = TypedDict(
    "_ClientListInvalidationsResponseTypeDef",
    {"InvalidationList": ClientListInvalidationsResponseInvalidationListTypeDef},
    total=False,
)


class ClientListInvalidationsResponseTypeDef(_ClientListInvalidationsResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **InvalidationList** *(dict) --*

        Information about invalidation batches.
        - **Marker** *(string) --*

          The value that you provided for the ``Marker`` request parameter.
    """


_ClientListPublicKeysResponsePublicKeyListItemsTypeDef = TypedDict(
    "_ClientListPublicKeysResponsePublicKeyListItemsTypeDef",
    {"Id": str, "Name": str, "CreatedTime": datetime, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientListPublicKeysResponsePublicKeyListItemsTypeDef(
    _ClientListPublicKeysResponsePublicKeyListItemsTypeDef
):
    pass


_ClientListPublicKeysResponsePublicKeyListTypeDef = TypedDict(
    "_ClientListPublicKeysResponsePublicKeyListTypeDef",
    {
        "NextMarker": str,
        "MaxItems": int,
        "Quantity": int,
        "Items": List[ClientListPublicKeysResponsePublicKeyListItemsTypeDef],
    },
    total=False,
)


class ClientListPublicKeysResponsePublicKeyListTypeDef(
    _ClientListPublicKeysResponsePublicKeyListTypeDef
):
    """
    - **PublicKeyList** *(dict) --*

      Returns a list of all public keys that have been added to CloudFront for this account.
      - **NextMarker** *(string) --*

        If there are more elements to be listed, this element is present and contains the value that
        you can use for the ``Marker`` request parameter to continue listing your public keys where
        you left off.
    """


_ClientListPublicKeysResponseTypeDef = TypedDict(
    "_ClientListPublicKeysResponseTypeDef",
    {"PublicKeyList": ClientListPublicKeysResponsePublicKeyListTypeDef},
    total=False,
)


class ClientListPublicKeysResponseTypeDef(_ClientListPublicKeysResponseTypeDef):
    """
    - *(dict) --*

      - **PublicKeyList** *(dict) --*

        Returns a list of all public keys that have been added to CloudFront for this account.
        - **NextMarker** *(string) --*

          If there are more elements to be listed, this element is present and contains the value
          that you can use for the ``Marker`` request parameter to continue listing your public keys
          where you left off.
    """


_ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef(
    _ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef
):
    pass


_ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef(
    _ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef
):
    pass


_ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef(
    _ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef
):
    pass


_ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "S3Origin": ClientListStreamingDistributionsResponseStreamingDistributionListItemsS3OriginTypeDef,
        "Aliases": ClientListStreamingDistributionsResponseStreamingDistributionListItemsAliasesTypeDef,
        "TrustedSigners": ClientListStreamingDistributionsResponseStreamingDistributionListItemsTrustedSignersTypeDef,
        "Comment": str,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef(
    _ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef
):
    pass


_ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[
            ClientListStreamingDistributionsResponseStreamingDistributionListItemsTypeDef
        ],
    },
    total=False,
)


class ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef(
    _ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef
):
    """
    - **StreamingDistributionList** *(dict) --*

      The ``StreamingDistributionList`` type.
      - **Marker** *(string) --*

        The value you provided for the ``Marker`` request parameter.
    """


_ClientListStreamingDistributionsResponseTypeDef = TypedDict(
    "_ClientListStreamingDistributionsResponseTypeDef",
    {
        "StreamingDistributionList": ClientListStreamingDistributionsResponseStreamingDistributionListTypeDef
    },
    total=False,
)


class ClientListStreamingDistributionsResponseTypeDef(
    _ClientListStreamingDistributionsResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistributionList** *(dict) --*

        The ``StreamingDistributionList`` type.
        - **Marker** *(string) --*

          The value you provided for the ``Marker`` request parameter.
    """


_ClientListTagsForResourceResponseTagsItemsTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTagsItemsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientListTagsForResourceResponseTagsItemsTypeDef(
    _ClientListTagsForResourceResponseTagsItemsTypeDef
):
    """
    - *(dict) --*

      A complex type that contains ``Tag`` key and ``Tag`` value.
      - **Key** *(string) --*

        A string that contains ``Tag`` key.
        The string length should be between 1 and 128 characters. Valid characters include ``a-z`` ,
        ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / = + @`` .
    """


_ClientListTagsForResourceResponseTagsTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTagsTypeDef",
    {"Items": List[ClientListTagsForResourceResponseTagsItemsTypeDef]},
    total=False,
)


class ClientListTagsForResourceResponseTagsTypeDef(_ClientListTagsForResourceResponseTagsTypeDef):
    """
    - **Tags** *(dict) --*

      A complex type that contains zero or more ``Tag`` elements.
      - **Items** *(list) --*

        A complex type that contains ``Tag`` elements.
        - *(dict) --*

          A complex type that contains ``Tag`` key and ``Tag`` value.
          - **Key** *(string) --*

            A string that contains ``Tag`` key.
            The string length should be between 1 and 128 characters. Valid characters include
            ``a-z`` , ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / =
                 + @`` .
    """


_ClientListTagsForResourceResponseTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTypeDef",
    {"Tags": ClientListTagsForResourceResponseTagsTypeDef},
    total=False,
)


class ClientListTagsForResourceResponseTypeDef(_ClientListTagsForResourceResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Tags** *(dict) --*

        A complex type that contains zero or more ``Tag`` elements.
        - **Items** *(list) --*

          A complex type that contains ``Tag`` elements.
          - *(dict) --*

            A complex type that contains ``Tag`` key and ``Tag`` value.
            - **Key** *(string) --*

              A string that contains ``Tag`` key.
              The string length should be between 1 and 128 characters. Valid characters include
              ``a-z`` , ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / = + @`` .
    """


_RequiredClientTagResourceTagsItemsTypeDef = TypedDict(
    "_RequiredClientTagResourceTagsItemsTypeDef", {"Key": str}
)
_OptionalClientTagResourceTagsItemsTypeDef = TypedDict(
    "_OptionalClientTagResourceTagsItemsTypeDef", {"Value": str}, total=False
)


class ClientTagResourceTagsItemsTypeDef(
    _RequiredClientTagResourceTagsItemsTypeDef, _OptionalClientTagResourceTagsItemsTypeDef
):
    """
    - *(dict) --*

      A complex type that contains ``Tag`` key and ``Tag`` value.
      - **Key** *(string) --***[REQUIRED]**

        A string that contains ``Tag`` key.
        The string length should be between 1 and 128 characters. Valid characters include ``a-z`` ,
        ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / = + @`` .
    """


_ClientTagResourceTagsTypeDef = TypedDict(
    "_ClientTagResourceTagsTypeDef", {"Items": List[ClientTagResourceTagsItemsTypeDef]}, total=False
)


class ClientTagResourceTagsTypeDef(_ClientTagResourceTagsTypeDef):
    """
    A complex type that contains zero or more ``Tag`` elements.
    - **Items** *(list) --*

      A complex type that contains ``Tag`` elements.
      - *(dict) --*

        A complex type that contains ``Tag`` key and ``Tag`` value.
        - **Key** *(string) --***[REQUIRED]**

          A string that contains ``Tag`` key.
          The string length should be between 1 and 128 characters. Valid characters include ``a-z``
          , ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / = + @`` .
    """


_ClientUntagResourceTagKeysTypeDef = TypedDict(
    "_ClientUntagResourceTagKeysTypeDef", {"Items": List[str]}, total=False
)


class ClientUntagResourceTagKeysTypeDef(_ClientUntagResourceTagKeysTypeDef):
    """
    A complex type that contains zero or more ``Tag`` key elements.
    - **Items** *(list) --*

      A complex type that contains ``Tag`` key elements.
      - *(string) --*

        A string that contains ``Tag`` key.
        The string length should be between 1 and 128 characters. Valid characters include ``a-z`` ,
        ``A-Z`` , ``0-9`` , space, and the special characters ``_ - . : / = + @`` .
    """


_RequiredClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_RequiredClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_OptionalClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"Comment": str},
    total=False,
)


class ClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef(
    _RequiredClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
    _OptionalClientUpdateCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
):
    """
    The identity's configuration information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``CloudFrontOriginAccessIdentityConfig`` object), a new origin access identity is created.
      If the ``CallerReference`` is a value already sent in a previous identity request, and the
      content of the ``CloudFrontOriginAccessIdentityConfig`` is identical to the original request
      (ignoring white space), the response includes the same information returned to the original
      request.
      If the ``CallerReference`` is a value you already sent in a previous request to create an
      identity, but the content of the ``CloudFrontOriginAccessIdentityConfig`` is different from
      the original request, CloudFront returns a ``CloudFrontOriginAccessIdentityAlreadyExists``
      error.
    """


_ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef = TypedDict(
    "_ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef",
    {"CallerReference": str, "Comment": str},
    total=False,
)


class ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef(
    _ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef
):
    pass


_ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef = TypedDict(
    "_ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef",
    {
        "Id": str,
        "S3CanonicalUserId": str,
        "CloudFrontOriginAccessIdentityConfig": ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigTypeDef,
    },
    total=False,
)


class ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef(
    _ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef
):
    """
    - **CloudFrontOriginAccessIdentity** *(dict) --*

      The origin access identity's information.
      - **Id** *(string) --*

        The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientUpdateCloudFrontOriginAccessIdentityResponseTypeDef = TypedDict(
    "_ClientUpdateCloudFrontOriginAccessIdentityResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentity": ClientUpdateCloudFrontOriginAccessIdentityResponseCloudFrontOriginAccessIdentityTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientUpdateCloudFrontOriginAccessIdentityResponseTypeDef(
    _ClientUpdateCloudFrontOriginAccessIdentityResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentity** *(dict) --*

        The origin access identity's information.
        - **Id** *(string) --*

          The ID for the origin access identity, for example, ``E74FTE3AJFJ256A`` .
    """


_ClientUpdateDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigAliasesTypeDef(
    _ClientUpdateDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientUpdateDistributionDistributionConfigCacheBehaviorsItemsTypeDef],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientUpdateDistributionDistributionConfigCustomErrorResponsesItemsTypeDef],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientUpdateDistributionDistributionConfigLoggingTypeDef(
    _ClientUpdateDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientUpdateDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientUpdateDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[ClientUpdateDistributionDistributionConfigOriginGroupsItemsTypeDef],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientUpdateDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientUpdateDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientUpdateDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigOriginsTypeDef",
    {"Quantity": int, "Items": List[ClientUpdateDistributionDistributionConfigOriginsItemsTypeDef]},
    total=False,
)


class ClientUpdateDistributionDistributionConfigOriginsTypeDef(
    _ClientUpdateDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigRestrictionsTypeDef",
    {"GeoRestriction": ClientUpdateDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef},
    total=False,
)


class ClientUpdateDistributionDistributionConfigRestrictionsTypeDef(
    _ClientUpdateDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_RequiredClientUpdateDistributionDistributionConfigTypeDef = TypedDict(
    "_RequiredClientUpdateDistributionDistributionConfigTypeDef", {"CallerReference": str}
)
_OptionalClientUpdateDistributionDistributionConfigTypeDef = TypedDict(
    "_OptionalClientUpdateDistributionDistributionConfigTypeDef",
    {
        "Aliases": ClientUpdateDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientUpdateDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientUpdateDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientUpdateDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientUpdateDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientUpdateDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientUpdateDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientUpdateDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientUpdateDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientUpdateDistributionDistributionConfigTypeDef(
    _RequiredClientUpdateDistributionDistributionConfigTypeDef,
    _OptionalClientUpdateDistributionDistributionConfigTypeDef,
):
    """
    The distribution's configuration information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``DistributionConfig`` object), CloudFront creates a new distribution.
      If ``CallerReference`` is a value that you already sent in a previous request to create a
      distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[ClientUpdateDistributionResponseDistributionActiveTrustedSignersItemsTypeDef],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef(
    _ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef(
    _ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "IncludeCookies": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateDistributionResponseDistributionDistributionConfigOriginsItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef",
    {
        "GeoRestriction": ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "Aliases": ClientUpdateDistributionResponseDistributionDistributionConfigAliasesTypeDef,
        "DefaultRootObject": str,
        "Origins": ClientUpdateDistributionResponseDistributionDistributionConfigOriginsTypeDef,
        "OriginGroups": ClientUpdateDistributionResponseDistributionDistributionConfigOriginGroupsTypeDef,
        "DefaultCacheBehavior": ClientUpdateDistributionResponseDistributionDistributionConfigDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ClientUpdateDistributionResponseDistributionDistributionConfigCacheBehaviorsTypeDef,
        "CustomErrorResponses": ClientUpdateDistributionResponseDistributionDistributionConfigCustomErrorResponsesTypeDef,
        "Comment": str,
        "Logging": ClientUpdateDistributionResponseDistributionDistributionConfigLoggingTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ClientUpdateDistributionResponseDistributionDistributionConfigViewerCertificateTypeDef,
        "Restrictions": ClientUpdateDistributionResponseDistributionDistributionConfigRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef(
    _ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef
):
    pass


_ClientUpdateDistributionResponseDistributionTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "InProgressInvalidationBatches": int,
        "DomainName": str,
        "ActiveTrustedSigners": ClientUpdateDistributionResponseDistributionActiveTrustedSignersTypeDef,
        "DistributionConfig": ClientUpdateDistributionResponseDistributionDistributionConfigTypeDef,
        "AliasICPRecordals": List[
            ClientUpdateDistributionResponseDistributionAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateDistributionResponseDistributionTypeDef(
    _ClientUpdateDistributionResponseDistributionTypeDef
):
    """
    - **Distribution** *(dict) --*

      The distribution's information.
      - **Id** *(string) --*

        The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientUpdateDistributionResponseTypeDef = TypedDict(
    "_ClientUpdateDistributionResponseTypeDef",
    {"Distribution": ClientUpdateDistributionResponseDistributionTypeDef, "ETag": str},
    total=False,
)


class ClientUpdateDistributionResponseTypeDef(_ClientUpdateDistributionResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **Distribution** *(dict) --*

        The distribution's information.
        - **Id** *(string) --*

          The identifier for the distribution. For example: ``EDFDVBD632BHDS5`` .
    """


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_RequiredClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_RequiredClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_OptionalClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef",
    {
        "Comment": str,
        "QueryArgProfileConfig": ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef(
    _RequiredClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef,
    _OptionalClientUpdateFieldLevelEncryptionConfigFieldLevelEncryptionConfigTypeDef,
):
    """
    Request to update a field-level encryption configuration.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique number that ensures the request can't be replayed.
    """


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef",
    {"Format": str, "ProfileId": str, "ContentType": str},
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef",
    {
        "ForwardWhenContentTypeIsUnknown": bool,
        "ContentTypeProfiles": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigContentTypeProfilesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef",
    {"QueryArg": str, "ProfileId": str},
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef",
    {
        "ForwardWhenQueryArgProfileIsUnknown": bool,
        "QueryArgProfiles": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigQueryArgProfilesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "QueryArgProfileConfig": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigQueryArgProfileConfigTypeDef,
        "ContentTypeProfileConfig": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigContentTypeProfileConfigTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionConfig": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionFieldLevelEncryptionConfigTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef
):
    """
    - **FieldLevelEncryption** *(dict) --*

      Return the results of updating the configuration.
      - **Id** *(string) --*

        The configuration ID for a field-level encryption configuration which includes a set of
        profiles that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientUpdateFieldLevelEncryptionConfigResponseTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionConfigResponseTypeDef",
    {
        "FieldLevelEncryption": ClientUpdateFieldLevelEncryptionConfigResponseFieldLevelEncryptionTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionConfigResponseTypeDef(
    _ClientUpdateFieldLevelEncryptionConfigResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryption** *(dict) --*

        Return the results of updating the configuration.
        - **Id** *(string) --*

          The configuration ID for a field-level encryption configuration which includes a set of
          profiles that specify certain selected data fields to be encrypted by specific public
          keys.
    """


_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_RequiredClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_RequiredClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {"Name": str},
)
_OptionalClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_OptionalClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef(
    _RequiredClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
    _OptionalClientUpdateFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
):
    """
    Request to update a field-level encryption profile.
    - **Name** *(string) --***[REQUIRED]**

      Profile name for the field-level encryption profile.
    """


_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef",
    {
        "PublicKeyId": str,
        "ProviderId": str,
        "FieldPatterns": ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsFieldPatternsTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef",
    {
        "Name": str,
        "CallerReference": str,
        "Comment": str,
        "EncryptionEntities": ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigEncryptionEntitiesTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef
):
    pass


_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef",
    {
        "Id": str,
        "LastModifiedTime": datetime,
        "FieldLevelEncryptionProfileConfig": ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileFieldLevelEncryptionProfileConfigTypeDef,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef
):
    """
    - **FieldLevelEncryptionProfile** *(dict) --*

      Return the results of updating the profile.
      - **Id** *(string) --*

        The ID for a field-level encryption profile configuration which includes a set of profiles
        that specify certain selected data fields to be encrypted by specific public keys.
    """


_ClientUpdateFieldLevelEncryptionProfileResponseTypeDef = TypedDict(
    "_ClientUpdateFieldLevelEncryptionProfileResponseTypeDef",
    {
        "FieldLevelEncryptionProfile": ClientUpdateFieldLevelEncryptionProfileResponseFieldLevelEncryptionProfileTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientUpdateFieldLevelEncryptionProfileResponseTypeDef(
    _ClientUpdateFieldLevelEncryptionProfileResponseTypeDef
):
    """
    - *(dict) --*

      - **FieldLevelEncryptionProfile** *(dict) --*

        Return the results of updating the profile.
        - **Id** *(string) --*

          The ID for a field-level encryption profile configuration which includes a set of profiles
          that specify certain selected data fields to be encrypted by specific public keys.
    """


_RequiredClientUpdatePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_RequiredClientUpdatePublicKeyPublicKeyConfigTypeDef", {"CallerReference": str}
)
_OptionalClientUpdatePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_OptionalClientUpdatePublicKeyPublicKeyConfigTypeDef",
    {"Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientUpdatePublicKeyPublicKeyConfigTypeDef(
    _RequiredClientUpdatePublicKeyPublicKeyConfigTypeDef,
    _OptionalClientUpdatePublicKeyPublicKeyConfigTypeDef,
):
    """
    Request to update public key information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique number that ensures that the request can't be replayed.
    """


_ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef = TypedDict(
    "_ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef",
    {"CallerReference": str, "Name": str, "EncodedKey": str, "Comment": str},
    total=False,
)


class ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef(
    _ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef
):
    pass


_ClientUpdatePublicKeyResponsePublicKeyTypeDef = TypedDict(
    "_ClientUpdatePublicKeyResponsePublicKeyTypeDef",
    {
        "Id": str,
        "CreatedTime": datetime,
        "PublicKeyConfig": ClientUpdatePublicKeyResponsePublicKeyPublicKeyConfigTypeDef,
    },
    total=False,
)


class ClientUpdatePublicKeyResponsePublicKeyTypeDef(_ClientUpdatePublicKeyResponsePublicKeyTypeDef):
    """
    - **PublicKey** *(dict) --*

      Return the results of updating the public key.
      - **Id** *(string) --*

        A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientUpdatePublicKeyResponseTypeDef = TypedDict(
    "_ClientUpdatePublicKeyResponseTypeDef",
    {"PublicKey": ClientUpdatePublicKeyResponsePublicKeyTypeDef, "ETag": str},
    total=False,
)


class ClientUpdatePublicKeyResponseTypeDef(_ClientUpdatePublicKeyResponseTypeDef):
    """
    - *(dict) --*

      - **PublicKey** *(dict) --*

        Return the results of updating the public key.
        - **Id** *(string) --*

          A unique ID assigned to a public key you've added to CloudFront.
    """


_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef",
    {
        "AwsAccountNumber": str,
        "KeyPairIds": ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsKeyPairIdsTypeDef,
    },
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef",
    {
        "Enabled": bool,
        "Quantity": int,
        "Items": List[
            ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersItemsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "CallerReference": str,
        "S3Origin": ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef
):
    pass


_ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "ActiveTrustedSigners": ClientUpdateStreamingDistributionResponseStreamingDistributionActiveTrustedSignersTypeDef,
        "StreamingDistributionConfig": ClientUpdateStreamingDistributionResponseStreamingDistributionStreamingDistributionConfigTypeDef,
    },
    total=False,
)


class ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef(
    _ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef
):
    """
    - **StreamingDistribution** *(dict) --*

      The streaming distribution's information.
      - **Id** *(string) --*

        The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientUpdateStreamingDistributionResponseTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionResponseTypeDef",
    {
        "StreamingDistribution": ClientUpdateStreamingDistributionResponseStreamingDistributionTypeDef,
        "ETag": str,
    },
    total=False,
)


class ClientUpdateStreamingDistributionResponseTypeDef(
    _ClientUpdateStreamingDistributionResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistribution** *(dict) --*

        The streaming distribution's information.
        - **Id** *(string) --*

          The identifier for the RTMP distribution. For example: ``EGTXBD79EXAMPLE`` .
    """


_ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef(
    _ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef
):
    pass


_ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef",
    {"Enabled": bool, "Bucket": str, "Prefix": str},
    total=False,
)


class ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef(
    _ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef
):
    pass


_ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef(
    _ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef
):
    pass


_ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef = TypedDict(
    "_ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef(
    _ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef
):
    pass


_RequiredClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_RequiredClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef",
    {"CallerReference": str},
)
_OptionalClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef = TypedDict(
    "_OptionalClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef",
    {
        "S3Origin": ClientUpdateStreamingDistributionStreamingDistributionConfigS3OriginTypeDef,
        "Aliases": ClientUpdateStreamingDistributionStreamingDistributionConfigAliasesTypeDef,
        "Comment": str,
        "Logging": ClientUpdateStreamingDistributionStreamingDistributionConfigLoggingTypeDef,
        "TrustedSigners": ClientUpdateStreamingDistributionStreamingDistributionConfigTrustedSignersTypeDef,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef(
    _RequiredClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef,
    _OptionalClientUpdateStreamingDistributionStreamingDistributionConfigTypeDef,
):
    """
    The streaming distribution's configuration information.
    - **CallerReference** *(string) --***[REQUIRED]**

      A unique value (for example, a date-time stamp) that ensures that the request can't be
      replayed.
      If the value of ``CallerReference`` is new (regardless of the content of the
      ``StreamingDistributionConfig`` object), CloudFront creates a new distribution.
      If ``CallerReference`` is a value that you already sent in a previous request to create a
      distribution, CloudFront returns a ``DistributionAlreadyExists`` error.
    """


_DistributionDeployedWaitWaiterConfigTypeDef = TypedDict(
    "_DistributionDeployedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class DistributionDeployedWaitWaiterConfigTypeDef(_DistributionDeployedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 60
    """


_InvalidationCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_InvalidationCompletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InvalidationCompletedWaitWaiterConfigTypeDef(_InvalidationCompletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 20
    """


_ListCloudFrontOriginAccessIdentitiesPaginatePaginationConfigTypeDef = TypedDict(
    "_ListCloudFrontOriginAccessIdentitiesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListCloudFrontOriginAccessIdentitiesPaginatePaginationConfigTypeDef(
    _ListCloudFrontOriginAccessIdentitiesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef = TypedDict(
    "_ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef",
    {"Id": str, "S3CanonicalUserId": str, "Comment": str},
    total=False,
)


class ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef(
    _ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef
):
    pass


_ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef = TypedDict(
    "_ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[
            ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListItemsTypeDef
        ],
    },
    total=False,
)


class ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef(
    _ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef
):
    """
    - **CloudFrontOriginAccessIdentityList** *(dict) --*

      The ``CloudFrontOriginAccessIdentityList`` type.
      - **Marker** *(string) --*

        Use this when paginating results to indicate where to begin in your list of origin access
        identities. The results include identities in the list that occur after the marker. To get
        the next page of results, set the ``Marker`` to the value of the ``NextMarker`` from the
        current page's response (which is also the ID of the last identity on that page).
    """


_ListCloudFrontOriginAccessIdentitiesPaginateResponseTypeDef = TypedDict(
    "_ListCloudFrontOriginAccessIdentitiesPaginateResponseTypeDef",
    {
        "CloudFrontOriginAccessIdentityList": ListCloudFrontOriginAccessIdentitiesPaginateResponseCloudFrontOriginAccessIdentityListTypeDef,
        "NextToken": str,
    },
    total=False,
)


class ListCloudFrontOriginAccessIdentitiesPaginateResponseTypeDef(
    _ListCloudFrontOriginAccessIdentitiesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **CloudFrontOriginAccessIdentityList** *(dict) --*

        The ``CloudFrontOriginAccessIdentityList`` type.
        - **Marker** *(string) --*

          Use this when paginating results to indicate where to begin in your list of origin access
          identities. The results include identities in the list that occur after the marker. To get
          the next page of results, set the ``Marker`` to the value of the ``NextMarker`` from the
          current page's response (which is also the ID of the last identity on that page).
    """


_ListDistributionsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListDistributionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListDistributionsPaginatePaginationConfigTypeDef(
    _ListDistributionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef",
    {"CNAME": str, "ICPRecordalStatus": Literal["APPROVED", "SUSPENDED", "PENDING"]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesCookiesTypeDef,
        "Headers": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef",
    {
        "PathPattern": str,
        "TargetOriginId": str,
        "ForwardedValues": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsForwardedValuesTypeDef,
        "TrustedSigners": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef",
    {"ErrorCode": int, "ResponsePagePath": str, "ResponseCode": str, "ErrorCachingMinTTL": int},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef",
    {
        "Quantity": int,
        "Items": List[Literal["GET", "HEAD", "POST", "PUT", "PATCH", "OPTIONS", "DELETE"]],
        "CachedMethods": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsCachedMethodsTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef",
    {
        "Forward": Literal["none", "whitelist", "all"],
        "WhitelistedNames": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesWhitelistedNamesTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef",
    {
        "QueryString": bool,
        "Cookies": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesCookiesTypeDef,
        "Headers": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesHeadersTypeDef,
        "QueryStringCacheKeys": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesQueryStringCacheKeysTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef",
    {
        "LambdaFunctionARN": str,
        "EventType": Literal[
            "viewer-request", "viewer-response", "origin-request", "origin-response"
        ],
        "IncludeBody": bool,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef",
    {
        "TargetOriginId": str,
        "ForwardedValues": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorForwardedValuesTypeDef,
        "TrustedSigners": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTrustedSignersTypeDef,
        "ViewerProtocolPolicy": Literal["allow-all", "https-only", "redirect-to-https"],
        "MinTTL": int,
        "AllowedMethods": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorAllowedMethodsTypeDef,
        "SmoothStreaming": bool,
        "DefaultTTL": int,
        "MaxTTL": int,
        "Compress": bool,
        "LambdaFunctionAssociations": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorLambdaFunctionAssociationsTypeDef,
        "FieldLevelEncryptionId": str,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef",
    {"Quantity": int, "Items": List[int]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef",
    {
        "StatusCodes": ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaStatusCodesTypeDef
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef",
    {"OriginId": str},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef",
    {
        "Id": str,
        "FailoverCriteria": ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsFailoverCriteriaTypeDef,
        "Members": ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsMembersTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsOriginGroupsItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef",
    {"HeaderName": str, "HeaderValue": str},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef",
    {
        "Quantity": int,
        "Items": List[
            ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersItemsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef",
    {"Quantity": int, "Items": List[Literal["SSLv3", "TLSv1", "TLSv1.1", "TLSv1.2"]]},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef",
    {
        "HTTPPort": int,
        "HTTPSPort": int,
        "OriginProtocolPolicy": Literal["http-only", "match-viewer", "https-only"],
        "OriginSslProtocols": ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigOriginSslProtocolsTypeDef,
        "OriginReadTimeout": int,
        "OriginKeepaliveTimeout": int,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef",
    {"OriginAccessIdentity": str},
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef",
    {
        "Id": str,
        "DomainName": str,
        "OriginPath": str,
        "CustomHeaders": ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomHeadersTypeDef,
        "S3OriginConfig": ListDistributionsPaginateResponseDistributionListItemsOriginsItemsS3OriginConfigTypeDef,
        "CustomOriginConfig": ListDistributionsPaginateResponseDistributionListItemsOriginsItemsCustomOriginConfigTypeDef,
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef",
    {
        "Quantity": int,
        "Items": List[ListDistributionsPaginateResponseDistributionListItemsOriginsItemsTypeDef],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef",
    {
        "RestrictionType": Literal["blacklist", "whitelist", "none"],
        "Quantity": int,
        "Items": List[str],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef",
    {
        "GeoRestriction": ListDistributionsPaginateResponseDistributionListItemsRestrictionsGeoRestrictionTypeDef
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef",
    {
        "CloudFrontDefaultCertificate": bool,
        "IAMCertificateId": str,
        "ACMCertificateArn": str,
        "SSLSupportMethod": Literal["sni-only", "vip"],
        "MinimumProtocolVersion": Literal[
            "SSLv3", "TLSv1", "TLSv1_2016", "TLSv1.1_2016", "TLSv1.2_2018"
        ],
        "Certificate": str,
        "CertificateSource": Literal["cloudfront", "iam", "acm"],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListItemsTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListItemsTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "Aliases": ListDistributionsPaginateResponseDistributionListItemsAliasesTypeDef,
        "Origins": ListDistributionsPaginateResponseDistributionListItemsOriginsTypeDef,
        "OriginGroups": ListDistributionsPaginateResponseDistributionListItemsOriginGroupsTypeDef,
        "DefaultCacheBehavior": ListDistributionsPaginateResponseDistributionListItemsDefaultCacheBehaviorTypeDef,
        "CacheBehaviors": ListDistributionsPaginateResponseDistributionListItemsCacheBehaviorsTypeDef,
        "CustomErrorResponses": ListDistributionsPaginateResponseDistributionListItemsCustomErrorResponsesTypeDef,
        "Comment": str,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
        "ViewerCertificate": ListDistributionsPaginateResponseDistributionListItemsViewerCertificateTypeDef,
        "Restrictions": ListDistributionsPaginateResponseDistributionListItemsRestrictionsTypeDef,
        "WebACLId": str,
        "HttpVersion": Literal["http1.1", "http2"],
        "IsIPV6Enabled": bool,
        "AliasICPRecordals": List[
            ListDistributionsPaginateResponseDistributionListItemsAliasICPRecordalsTypeDef
        ],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListItemsTypeDef(
    _ListDistributionsPaginateResponseDistributionListItemsTypeDef
):
    pass


_ListDistributionsPaginateResponseDistributionListTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseDistributionListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[ListDistributionsPaginateResponseDistributionListItemsTypeDef],
    },
    total=False,
)


class ListDistributionsPaginateResponseDistributionListTypeDef(
    _ListDistributionsPaginateResponseDistributionListTypeDef
):
    """
    - **DistributionList** *(dict) --*

      The ``DistributionList`` type.
      - **Marker** *(string) --*

        The value you provided for the ``Marker`` request parameter.
    """


_ListDistributionsPaginateResponseTypeDef = TypedDict(
    "_ListDistributionsPaginateResponseTypeDef",
    {
        "DistributionList": ListDistributionsPaginateResponseDistributionListTypeDef,
        "NextToken": str,
    },
    total=False,
)


class ListDistributionsPaginateResponseTypeDef(_ListDistributionsPaginateResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **DistributionList** *(dict) --*

        The ``DistributionList`` type.
        - **Marker** *(string) --*

          The value you provided for the ``Marker`` request parameter.
    """


_ListInvalidationsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListInvalidationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListInvalidationsPaginatePaginationConfigTypeDef(
    _ListInvalidationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_ListInvalidationsPaginateResponseInvalidationListItemsTypeDef = TypedDict(
    "_ListInvalidationsPaginateResponseInvalidationListItemsTypeDef",
    {"Id": str, "CreateTime": datetime, "Status": str},
    total=False,
)


class ListInvalidationsPaginateResponseInvalidationListItemsTypeDef(
    _ListInvalidationsPaginateResponseInvalidationListItemsTypeDef
):
    pass


_ListInvalidationsPaginateResponseInvalidationListTypeDef = TypedDict(
    "_ListInvalidationsPaginateResponseInvalidationListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[ListInvalidationsPaginateResponseInvalidationListItemsTypeDef],
    },
    total=False,
)


class ListInvalidationsPaginateResponseInvalidationListTypeDef(
    _ListInvalidationsPaginateResponseInvalidationListTypeDef
):
    """
    - **InvalidationList** *(dict) --*

      Information about invalidation batches.
      - **Marker** *(string) --*

        The value that you provided for the ``Marker`` request parameter.
    """


_ListInvalidationsPaginateResponseTypeDef = TypedDict(
    "_ListInvalidationsPaginateResponseTypeDef",
    {
        "InvalidationList": ListInvalidationsPaginateResponseInvalidationListTypeDef,
        "NextToken": str,
    },
    total=False,
)


class ListInvalidationsPaginateResponseTypeDef(_ListInvalidationsPaginateResponseTypeDef):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **InvalidationList** *(dict) --*

        Information about invalidation batches.
        - **Marker** *(string) --*

          The value that you provided for the ``Marker`` request parameter.
    """


_ListStreamingDistributionsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListStreamingDistributionsPaginatePaginationConfigTypeDef(
    _ListStreamingDistributionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef",
    {"Quantity": int, "Items": List[str]},
    total=False,
)


class ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef(
    _ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef
):
    pass


_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef",
    {"DomainName": str, "OriginAccessIdentity": str},
    total=False,
)


class ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef(
    _ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef
):
    pass


_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef",
    {"Enabled": bool, "Quantity": int, "Items": List[str]},
    total=False,
)


class ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef(
    _ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef
):
    pass


_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef",
    {
        "Id": str,
        "ARN": str,
        "Status": str,
        "LastModifiedTime": datetime,
        "DomainName": str,
        "S3Origin": ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsS3OriginTypeDef,
        "Aliases": ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsAliasesTypeDef,
        "TrustedSigners": ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTrustedSignersTypeDef,
        "Comment": str,
        "PriceClass": Literal["PriceClass_100", "PriceClass_200", "PriceClass_All"],
        "Enabled": bool,
    },
    total=False,
)


class ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef(
    _ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef
):
    pass


_ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef",
    {
        "Marker": str,
        "NextMarker": str,
        "MaxItems": int,
        "IsTruncated": bool,
        "Quantity": int,
        "Items": List[
            ListStreamingDistributionsPaginateResponseStreamingDistributionListItemsTypeDef
        ],
    },
    total=False,
)


class ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef(
    _ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef
):
    """
    - **StreamingDistributionList** *(dict) --*

      The ``StreamingDistributionList`` type.
      - **Marker** *(string) --*

        The value you provided for the ``Marker`` request parameter.
    """


_ListStreamingDistributionsPaginateResponseTypeDef = TypedDict(
    "_ListStreamingDistributionsPaginateResponseTypeDef",
    {
        "StreamingDistributionList": ListStreamingDistributionsPaginateResponseStreamingDistributionListTypeDef,
        "NextToken": str,
    },
    total=False,
)


class ListStreamingDistributionsPaginateResponseTypeDef(
    _ListStreamingDistributionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      The returned result of the corresponding request.
      - **StreamingDistributionList** *(dict) --*

        The ``StreamingDistributionList`` type.
        - **Marker** *(string) --*

          The value you provided for the ``Marker`` request parameter.
    """


_StreamingDistributionDeployedWaitWaiterConfigTypeDef = TypedDict(
    "_StreamingDistributionDeployedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class StreamingDistributionDeployedWaitWaiterConfigTypeDef(
    _StreamingDistributionDeployedWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 60
    """
